/* @(#)globals.h	1.16 for x.c 11/23/95 */

#ifndef __GLOBALS.H__
#define __GLOBALS.H__

#include "config.h"

#define VERSION "1.16"

typedef struct hapsys {
	int first;
	int count;
	int ord;
	int rest[MAXHAPSIZE];
	struct hapsys *next;
} HAPSYS;
typedef struct child {
	int id;
	char *fchrom;
	char *mchrom;
	int fcross;
	int mcross;
	struct child *next;
} CHILD;
typedef struct family {
	int id;
	float like;
	int has_gp;
	int size;
	CHILD *sibs;
	struct family *next;
} FAMILY;
typedef struct mapelement {
	int ord;
	char *name;
	float fdist;
	float mdist;
	struct mapelement *next;
} MAPELEMENT;
typedef struct candidate {
	int fam, id;
	char sex;
	int map_pos;
	int flank1, flank2;
	float distance;
	char *chrom;
	struct candidate *next;
} CANDIDATE;
typedef struct crossover {
	int fam, id;
	char sex;
	int left, right;
	int gap;
	int lcount, rcount;
	int before, after;
	int leftscore,rightscore,score;
	char *chrom;
	struct crossover *next;
} CROSSOVER;

#ifdef __MAIN__
FILE *in,*out,*logfile,*dat, *hapfile;
char line[LINEBUFSIZE],inbuf[FILEBUFSIZE],msg[LINEBUFSIZE];
char *chromosome;
char *names[MAXLOC];
char *chrompic_name = CHROMPIC;
int use_haps;
int hapcount = 0, hap0count = 0, loccount = 0, famcount = 0;
int minscore = MINSCORE, verbosity = VERBOSITY;
float flen, mlen;
float fam_like_tol = FAM_LIKE_TOL, typ_per_cm_tol = TYP_PER_CM_TOL;
float male_map_tol = MALE_MAP_TOL, female_map_tol = FEMALE_MAP_TOL;
float puk_factor = PUK_SCORE_FACTOR;
int hapfirst[MAXLOC], hapmember[MAXLOC],order[MAXMAP];
HAPSYS *haparray[MAXHAP],*hap0array[MAXHAP], *haps = NULL;
FAMILY *fams = NULL;
MAPELEMENT *map = NULL;
CANDIDATE *fcand = NULL, *mcand = NULL;
CROSSOVER *crossovers = NULL;


int read_chrompic();
int analyse();

static char SccsId[] = "@(#)globals.h	1.16\t11/23/95";


#else
extern FILE *in,*out,*logfile,*dat, *hapfile;
extern char line[LINEBUFSIZE],inbuf[FILEBUFSIZE],msg[LINEBUFSIZE];
extern char *chromosome;
extern char *names[MAXLOC];
extern char *chrompic_name;
extern int use_haps;
extern int hapcount, hap0count, loccount, famcount;
extern int minscore, verbosity;
extern float flen, mlen;
extern float fam_like_tol, typ_per_cm_tol;
extern float male_map_tol, female_map_tol;
extern float puk_factor;
extern int hapfirst[MAXLOC], hapmember[MAXLOC],order[MAXMAP];
extern HAPSYS *haparray[MAXHAP],*hap0array[MAXHAP], *haps;
extern FAMILY *fams;
extern MAPELEMENT *map;
extern CANDIDATE *fcand,*mcand;
extern CROSSOVER *crossovers;

#endif

#endif
