/* @(#)input.c	1.16 for x.c 11/23/95 */

#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#ifdef __TURBOC__
#include <alloc.h>
#include <math.h>
#else
#include <malloc.h>
#include <sys/types.h>
#endif

#include "config.h"
#include "globals.h"
#include "x_utils.h"

int fatal = 0;

int getpars()	{

	sprintf(msg,"\n----------------------------------- CRI-Map parameter settings\n\n");
	putlog(msg,LOG_NOTICE);
	if (strcmp(firstword(),"chromosome"))
		die(ERRBAD,"CRI-Map");
	chromosome = strdup(nextword());
	sprintf(msg,"Chromosome %s\n",chromosome);
	putlog(msg,LOG_INFO);
	if (strcmp(firstword(),"Option"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(nextword(),"chosen:"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(nextword(),"chrompic"))
		die(ERRBAD,"CRI-Map chrompic");
	if (strcmp(firstword(),"Current"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"par_file"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"dat_file"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"gen_file"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"ord_file"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"nb_our_alloc"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"SEX_EQ"))
		die(ERRBAD,"CRI-Map");
	nextword();
	if (strcmp(nextword(),"0"))
		die(ERRSEXEQ,"");
	if (strcmp(firstword(),"TOL"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"PUK_NUM_ORDERS_TOL"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"PK_NUM_ORDERS_TOL"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"PUK_LIKE_TOL"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"PK_LIKE_TOL"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"use_ord_file"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"write_ord_file"))
		die(ERRBAD,"CRI-Map");
	if (strcmp(firstword(),"use_haps"))
		die(ERRBAD,"CRI-Map");
	nextword();
	use_haps = strcmp(nextword(),"0");
	sprintf(msg,"%s haplotypes\n",use_haps ? "Using" : "Ignoring");
	putlog(msg,LOG_INFO);
	return 0;
}

int gethap_sys() {
	int i;
	char *s;
	HAPSYS *p;

	if (hapcount + 1 >= MAXHAP)
		die(ERR2MANY,"hap_sys");
	if ((p = (HAPSYS *) malloc(sizeof(HAPSYS))) == NULL)
		die(ERRNOMEM,"");
	p->count = 0; p->first = -1; p->next = NULL;
	getline(in);
	do {
		s = thisword();
		do { 
			i = strtoi(s);
			if (i >= MAXLOC)
				die(ERR2BIG,"Locus number");
			if (p->count == 0) {
				p->first = i;
				++hapfirst[i];
			} else
				++hapmember[i];
			if (p->count + 1 >= MAXHAPSIZE)
				die(ERR2MANY,"hap_sys members");
			p->rest[p->count] = i;
			names[i] = strdup(nextword());
			s = nextword();
			++(p->count);
		} while (s);
		getline(in);
	} while (strncmp(line,"Haplotyped",10) && strncmp(line,"N.B.",4));
	haparray[hapcount] = p;
	++hapcount;
	return 0;
}

int gethap_sys0() {
	int i;
	char *s;
	HAPSYS *p;

	if (hap0count + 1 >= MAXHAP)
		die(ERR2MANY,"hap_sys0");
	if ((p = (HAPSYS *) malloc(sizeof(HAPSYS))) == NULL)
		die(ERRNOMEM,"");
	p->count = 0; p->first = -1; 
	getline(in);
	do {
		s = thisword();
		do {
			i = strtoi(s);
			if (i >= MAXLOC)
				die(ERR2BIG,"Locus number");
			if (p->count == 0) {
				p->first = i;
				++hapfirst[i];
			} else
				++hapmember[i];
			if (p->count + 1 >= MAXHAPSIZE)
				die(ERR2MANY,"hap_sys0 members");
			p->rest[p->count] = i;
			names[i] = strdup(nextword());
			s = nextword();
			++(p->count);
		} while (s);
		getline(in);
	} while (strncmp(line,"Haplotyped",10) && strncmp(line,"N.B.",4));
	hap0array[hap0count] = p;
	++hap0count;
	return 0;
}

int gethaps() {
	int i,j;
	HAPSYS *p;
	
	sprintf(msg,"\n----------------------------------- Haplotyped systems\n\n");
	putlog(msg,LOG_NOTICE);
	getline(in);
	while (strncmp(line,"Haplotyped",10) == 0) {
		if (strstr(line,"not"))
			gethap_sys();
		else
			gethap_sys0();
	}
	if (strncmp(line,"N.B.",4) || strcmp(firstword(),"objects,"))
		die(ERRHAP,"");
	sprintf(msg,"Found %d hap_sys & %d hap_sys0 systems\n",hapcount,hap0count);
	putlog(msg,LOG_INFO);
	for (i = 0; i < hapcount; i++) {
		p = haparray[i];
		sprintf(msg,"Hap_sys: %d", p->first);
		putlog(msg,LOG_INFO);
		for (j = 1; j < p->count; j++) {
			sprintf(msg," %d",p->rest[j]);
			putlog(msg,LOG_INFO);
		}
		sprintf(msg," (%s",names[p->first]);
		putlog(msg,LOG_INFO);
		for (j = 1; j < p->count; j++) {
			sprintf(msg," %s",names[p->rest[j]]);
			putlog(msg,LOG_INFO);
		}
		putlog(")\n",LOG_INFO);
	}
	for (i = 0; i < hap0count; i++) {
		p = hap0array[i];
		sprintf(msg,"Hap_sys0: %d", p->first);
		putlog(msg,LOG_INFO);
		for (j = 1; j < p->count; j++) {
			sprintf(msg," %d",p->rest[j]);
			putlog(msg,LOG_INFO);
		}
		sprintf(msg," (%s",names[p->first]);
		putlog(msg,LOG_INFO);
		for (j = 1; j < p->count; j++) {
			sprintf(msg," %s",names[p->rest[j]]);
			putlog(msg,LOG_INFO);
		}
		putlog(")\n",LOG_INFO);
	}
	for (i = 0; i < MAXLOC; i++) {
		if (hapfirst[i] > 1) {
			sprintf(msg,"***WARNING: Locus %d (%s) leads more than one hapsys\n",
				i,names[i]);
			putlog(msg,LOG_WARNING);
			++fatal;
		}
		if (hapmember[i] > 1) {
			sprintf(msg,"***WARNING: Locus %d (%s) is a member of more than one hapsys\n",
				i,names[i]);
			putlog(msg,LOG_WARNING);
			++fatal;
		}
		if (hapfirst[i] && hapmember[i]) {
			sprintf(msg,"***WARNING: Locus %d (%s) leads a hapsys and is a member of other(s)\n",
				i,names[i]);
			putlog(msg,LOG_WARNING);
			++fatal;
		}
	}
	return 0;
}

int getorder() {
	int i;

	sprintf(msg,"\n----------------------------------- Map order\n\n");
	putlog(msg,LOG_NOTICE);
	getline(in);
	while (strncmp(line,"gen_file",8)) {
		i = strtoi(thisword());
		if (i >= MAXLOC)
			die(ERR2BIG,"Locus number");
		names[i] = strdup(nextword());
		if (loccount + 1 >= MAXMAP)
			die(ERR2MANY,"map points");
		order[loccount++] = i;
		getline(in);
	}
	for (i = 0; i < loccount; i++) {
		sprintf(msg,"%3d: %4d %s\n", i, order[i], names[order[i]]);
		putlog(msg,LOG_INFO);
	}
	return 0;
}

int getfams() {
	FAMILY *f,*lastfam = NULL;
	CHILD *c, *lastchild = NULL;
	int id;

	sprintf(msg,"\n----------------------------------- Families/chromosomes\n\n");
	putlog(msg,LOG_NOTICE);
	getline(in);
	while(strncmp(line,"Family",6) == 0) {
		if ((f = (FAMILY *) malloc(sizeof(FAMILY))) == NULL)
			die(ERRNOMEM,"");
		f->size = 0; 
		thisword();
		f->id = strtoi(nextword());
		nextword();
		nextword();
		nextword();
/*		sscanf(nextword(),"%f",&f->like);
*/
		f->like = strtof(nextword());
		f->sibs = NULL;
		f->next = NULL;
		f->has_gp = 0;
		if (fams)
			lastfam->next = f;
		else
			fams = f;
		lastfam = f;
		lastchild = NULL;
		getline(in);
		do {
			sscanf(line," %d",&id);
			if (id > 2) {
				if ((c = (CHILD *) malloc(sizeof(CHILD))) == NULL)
					die(ERRNOMEM,"");
				c->id = id;
				c->fchrom = strdup(line);
				getline(in);
				if (strncmp(line,"         ",9) == 0)
					getline(in);
				c->mchrom = strdup(line);
				c->next = NULL;
				if (f->sibs)
					lastchild->next = c;
				else
					f->sibs = c;
				lastchild = c;
			} else {
				++f->has_gp;
				getline(in);
			}
			getline(in);
			if (strncmp(line,"         ",9) == 0)
				getline(in);
		} while (strncmp(line,"Family",6) && strncmp(line,"CROSSOVER",9));
		
	}
	f = fams;
	while (f) {
		sprintf(msg,"Family %d, Phase likelihood %5.3f\n", f->id,f->like);
		putlog(msg,LOG_INFO);
/*
		c = f->sibs;
		while (c) {
			sprintf(msg,"%s\n%s\n",c->fchrom,c->mchrom);
			putlog(msg,LOG_INFO);
			c = c->next;
		}
*/
		f = f->next;
	}
	return 0;
}

int getindex() {
	int m1, m2;
	char *s;

	sprintf(msg,"\n----------------------------------- Crossover index\n\n");
	putlog(msg,LOG_NOTICE);
	getline(in);
	do {
		m1 = strtoi(thisword());
		m2 = strtoi(nextword());
/*		sprintf(msg,"\n%d %d:",m1,m2);
		putlog(msg,LOG_INFO);
*/
		getline(in);
		while (strpbrk(line,"-")) {
			s = thisword();
/*			sprintf(msg," %s",s);
			putlog(msg,LOG_INFO);
			while ((s = nextword())) {
				sprintf(msg," %s",s);
				putlog(msg,LOG_INFO);
				
			}
*/
			getline(in);
		}
	} while (strncmp(line,"CONSECUTIVE",11));
	putlog("\n",LOG_INFO);
	getline(in);
	sprintf(msg,"\n----------------------------------- Consecutive non-recombinant markers\n\n");
	putlog(msg,LOG_NOTICE);
	do {

		getline(in);
	} while (strncmp(line,"Sex-specific",12));
	return 0;
}
							 
int getmap() {
	MAPELEMENT *el, *last = NULL;

	sprintf(msg,"\n----------------------------------- Map section\n\n");
	putlog(msg,LOG_NOTICE);
	getline(in);
	do {
		if ((el = (MAPELEMENT *) malloc(sizeof(MAPELEMENT))) == NULL)
			die(ERRNOMEM,"");
		el->ord = strtoi(thisword());
		el->name = strdup(nextword());
/*		sscanf(nextword(),"%f",&el->fdist);
		sscanf(nextword(),"%f",&el->mdist);
*/
		el->fdist = strtof(nextword());
		el->mdist = strtof(nextword());
		el->next = NULL;
		if (map) 
			last->next = el;
		else
			map = el;
		last = el;
		getline(in);	
		getline(in);
	} while (strncmp(line,"log10_like",10));
	mlen = last->mdist; flen = last->fdist;
	el = map;
	while (el) {
		sprintf(msg,"%3d %-12s %5.1f %5.1f\n", el->ord, el->name, el->fdist, el->mdist);
		putlog(msg,LOG_INFO);
		el = el->next;
	}
	sprintf(msg,"\nTotals: female length = %5.1f, male length = %5.1f\n", flen, mlen);
	putlog(msg,LOG_INFO);
	return 0;
}

int read_chrompic() {
	getpars();
	gethaps();
	getorder();
	getfams();
	getindex();
	getmap();
	if (fatal) {
		sprintf(msg,"%d fatal errors detected in chrompic file. Cannot proceed with analysis.", fatal);
		die(ERRFAIL,msg);
	}
	return 0;
}
							 
