/* @(#)rcparse.c	1.16 11/23/95 */

#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#ifdef __TURBOC__
#include <alloc.h>
#include <math.h>
#else
#include <malloc.h>
#include <sys/types.h>
#endif

#include "config.h"
#include "globals.h"
#include "x_utils.h"
#include "rcparse.h"


int next_char(f)
FILE *f;	{
	static int eol;

	while (cp == NULL || *cp == '\0') {
		if (feof(f))
			return(EOF);
		fgets(line,LINEBUFSIZE,f);
		line[strlen(line) -1] = '\0';
		cp = line; eol = 1; ++rcline;
	}
	if (eol) {
		eol = 0;
		return feof(f) ? EOF : '\n';
	} else 
		return *cp++;
}

char *get_next_tok(f)
FILE *f;	{
	char *tp;

again:
	while (cp == NULL || isspace(ch))
		ch = next_char(f);
	tp = tok; toktype = TOK_BAD;
	if (isalpha(ch)) { /* Identifier */
		do {
			*tp++ = ch;
			ch = next_char(f);
		} while (isalnum(ch) || ch == '_');
		toktype = TOK_ID;
	} else if (ch == '"') { /* String literal */
		ch = next_char(f);
		while (ch != '"' && ch != '\n' && ch != EOF) {
			*tp++ = ch;
			ch = next_char(f);
		}
		if (ch == '\n' || ch == EOF) {
			sprintf(line,"%d of rc file %s:\n\tUnmatched double quotes\n",rcline,RCFILE);
			die(ERRSYNTAX,line);
		} else
			ch = next_char(f);
		toktype = TOK_STR;
	} else if (ch == '#') { /* Cooment */
		do {
			ch = next_char(f);
		} while (ch != '\n' && ch != EOF);
		goto again;
	} else if (isdigit(ch)) { /* number */
		do {
			*tp++ = ch;
			ch = next_char(f);
		} while (isdigit(ch));
		toktype = TOK_INT;
		if (ch == '.') { /* floating-point number */
			do {
				*tp++ = ch;
				ch = next_char(f);
			} while (isdigit(ch));
			toktype = TOK_REAL;
		}
	} else if (ch == EOF) {
		*tp++ = '\0'; 
		toktype = TOK_EOF;
	} else {
		*tp++ = ch;
		toktype = TOK_SYM;
		ch = next_char(f);
	}
	*tp = '\0';
	switch (toktype) {
		case TOK_INT: intval = strtoi(tok); break;
		case TOK_REAL: realval = strtof(tok); break;
	}
	return tok;
}

char *next_tok() {
	return (get_next_tok(rc));
}

int mustbe(s)
char *s;	{
	
	if (strcmp(s,next_tok())) {
		sprintf(line,"%d of rc file %s:\n\t%s '%s' encountered when '%s' expected\n", rcline,RCFILE,toktypes[toktype],tok,s);
		die(ERRSYNTAX,line);
	}
	return 1;
}

int have(s)
char *s;	{
	
	if (strcmp(s,tok))
		return 0;
	else {
		next_tok();
		return 1;
	}
}

int expect(t)
int t;	{
	if (toktype != t) {
		sprintf(line,"%d of rc file %s:\n\t%s '%s' encountered when %s expected\n", rcline,RCFILE,toktypes[toktype],tok,toktypes[t]);
		die(ERRSYNTAX,line);
	}
	return 1;
}
