/* @(#)x_utils.c	1.16 for x.c 11/23/95 */

#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#ifdef __TURBOC__
#include <alloc.h>
#include <math.h>
#else
#include <malloc.h>
#include <sys/types.h>
#endif

#include "config.h"
#include "globals.h"
#include "x_utils.h"

char *error[] = {
	"\nBad error code: %d\n",
	"Unable to open file %s",
	"Unexpected EOF",
	"Not a %s file",
	"Cannot work from a sex-pooled map",
	"Problem while reading haplotyped systems",
	"Out of memory",
	"Too many %s",
	"%s too large",
	"%s",
	"Syntax error in or near line %s"
};


int putlog(s,level)
char *s;
int level;	{
	if (level <= verbosity)
		fprintf(stderr,s);
	fprintf(logfile,s);
	return 0;
}

int die(errcode,s)
int errcode;
char *s;	{
	putlog("\nERROR: ",LOG_CRIT);
	if (errcode < 0 || errcode >= sizeof(error) / sizeof(char *)) {
		sprintf(msg,error[0],errcode);
		putlog(msg,LOG_CRIT);
		exit(-1);
	}
	if (s) {
		sprintf(msg,error[errcode],s);
		putlog(msg,LOG_CRIT);
	} else
		putlog(error[errcode],LOG_CRIT);
	putlog("\n",LOG_CRIT);
	exit(errcode);
	return 0;
}

int isnoise(s)
char *s;	{
	int flag = 0;
	if (strlen(s) == 0)
		flag = 1;
	else if ((strstr(line,"bytes allocated")) != NULL)
		flag = 1;
	return flag;
}

char *getline(f)
FILE *f;	{
	do {
		if (feof(f))
			die(ERREOF,"");
		fgets(line,LINEBUFSIZE,f);
		line[strlen(line) -1] = '\0';
	} while (isnoise(line));
	return line;
}

char *firstword() {
	getline(in);
	return strtok(line," \t");
}

char *thisword() {
	return strtok(line," \t");
}

char *nextword() {
	return strtok((char *) NULL," \t");
}

int strtoi(s)
char *s; {
	long strtol();

	return (int) strtol(s,(char **) NULL, 10);
}

float strtof(s)
char *s; {
	float x;

	sscanf(s,"%f",&x);
	return x;
}

char *pretty(s)
char *s;	{
	int i;
	char *p = line;

	for (i = 0; *s; i++) {
		if (i && i % 10 == 0)
			*p++ = ' ';
		*p++ = *s++;
	}
	*p = '\0';
	return line;
}

MAPELEMENT *lookup(i)
int i;	{
	MAPELEMENT *m = map;

	while (m && i--)
		m = m->next;
	return m;
}

#ifdef ULTRIX

char *strdup(old)
char *old; {
        char *new;

        if (old == NULL)
                return NULL;
        if ((new = malloc(strlen(old) + 1)) == NULL)
                return NULL;
        return (strcpy(new,old));
}

#endif
